*char ODU_NAME		= "OwnDevUnit.library";

/* strings that can be returned by LockDevUnit() and AttempDevUnit() to
   indicate an internal error.	Note that these all start with a
   special character to allow clients to only have to check one byte
   to determine if an error occured. */

char ODUERR_LEADCHAR	= '\(0x07)';

*char
    ODUERR_NOMEM	= "\(ODUERR_LEADCHAR)Out of memory",
    ODUERR_NOTIMER	= "\(ODUERR_LEADCHAR)Unable to open timer.device",
    ODUERR_BADNAME	= "\(ODUERR_LEADCHAR)Bogus device name supplied",
    ODUERR_BADBIT	= "\(ODUERR_LEADCHAR)Bogus notify bit supplied",
    ODUERR_UNKNOWN	= "\(ODUERR_LEADCHAR)Unknown";
				/* returned if owner's name is NULL */

/* prototypes for the functions found in this library */
extern
    LockDevUnit(*char device; ulong unit; *char ownerName;
		ulong notifyBit)*char,
    AttemptDevUnit(*char device; ulong unit; *char ownerName;
		   ulong notifyBit)*char,
    FreeDevUnit(*char device; ulong unit)void,
    NameDevUnit(*char device; ulong unit; *char ownerName)void,
    AvailDevUnit(*char device; ulong unit)bool,
    OwnerDevUnit(*char device; ulong unit)*char;

extern
    OpenOwnDevUnitLibrary(ulong version)*Library_t,
    CloseOwnDevUnitLibrary()void;
