type
    ViewPort_t = unknown 40,
    RastPort_t = unknown 100,
    BitMap_t = unknown 40,
    Layer_Info_t = unknown 102;

type
    Screen_t = struct {
	*Screen_t sc_NextScreen;
	*Window_t sc_FirstWindow;
	
	uint sc_LeftEdge, sc_TopEdge;
	uint sc_Width, sc_Height;
	
	int sc_MouseY, sc_MouseX;
	
	uint sc_Flags;
	
	*char sc_Title;
	*char sc_DefaultTitle;
	
	ushort sc_BarHeight, sc_BarVBorder, sc_BarHBorder,
	    sc_MenuVBorder, sc_MenuHBorder;
	ushort sc_WBorTop, sc_WBorLeft, sc_WBorRight, sc_WBorBottom;
	
	*TextAttr_t sc_Font;
	
	ViewPort_t sc_ViewPort;
	RastPort_t sc_RastPort;
	BitMap_t sc_BitMap;
	Layer_Info_t sc_LayerInfo;
	
	*Gadget_t sc_FirstGadget;
	
	ushort sc_DetailPen, sc_BlockPen;
	
	uint sc_SaveColor0;
	
	*Layer_t sc_BarLayer;
	
	*byte sc_ExtData;
	
	*byte sc_UserData;
    };

uint	
    SCREENTYPE	    = 0x000F,
    WBENCHSCREEN    = 0x0001,
    CUSTOMSCREEN    = 0x000F,

    SHOWTITLE	    = 0x0010,

    BEEPING	    = 0x0020,

    CUSTOMBITMAP    = 0x0040,

    SCREENBEHIND    = 0x0080,

    SCREENQUIET     = 0x0100,

    PENSHARED	    = 0x0400,

    NS_EXTENDED     = 0x1000,

    AUTOSCROLL	    = 0x4000;

uint
    STDSCREENHEIGHT = 65535;

ulong
    SA_DUMMY	= (TAG_USER + 32),

/* tags with values */

    SA_Left	= SA_DUMMY + 0x0001,
    SA_Top	= SA_DUMMY + 0x0002,
    SA_Width	= SA_DUMMY + 0x0003,
    SA_Height	= SA_DUMMY + 0x0004,
    SA_Depth	= SA_DUMMY + 0x0005,
    SA_DetailPen= SA_DUMMY + 0x0006,
    SA_BlockPen = SA_DUMMY + 0x0007,
    SA_Title	= SA_DUMMY + 0x0008,
    SA_Colors	= SA_DUMMY + 0x0009,	/* -1 term array of struct ColorSpec */
    SA_ErrorCode= SA_DUMMY + 0x000a,	/* ptr to ulong error code */
    SA_Font	= SA_DUMMY + 0x000b,
    SA_SysFont	= SA_DUMMY + 0x000c,	/* 0 - old pref font, 1 - wb pref */
    SA_Type	= SA_DUMMY + 0x000d,	/* only PUBLICSCREEN, CUSTOMSCREEN */
    SA_BitMap	= SA_DUMMY + 0x000e,
    SA_PubName	= SA_DUMMY + 0x000f,	/* no value. Do before next two */
    SA_PubSig	= SA_DUMMY + 0x0010,
    SA_PubTask	= SA_DUMMY + 0x0011,	/* task & signal for last window note*/
    SA_DisplayID= SA_DUMMY + 0x0012,	/* new extended display ID */
    SA_DClip	= SA_DUMMY + 0x0013,	/* ptr to clip rectangle */
    SA_Overscan = SA_DUMMY + 0x0014,
    SA_Obsolete1= SA_DUMMY + 0x0015,

/* boolean tags */

    SA_ShowTitle= SA_DUMMY + 0x0016,
    SA_Behind	= SA_DUMMY + 0x0017,
    SA_Quiet	= SA_DUMMY + 0x0018,
    SA_AutoScroll=SA_DUMMY + 0x0019,
    SA_Pens	= SA_DUMMY + 0x001a,	/* ptr to ~0 term uword array */
    SA_FullPalette=SA_DUMMY+ 0x001b,
    SA_ColorMapEntries=SA_DUMMY+0x001c,
    SA_Parent	= SA_DUMMY + 0x001d,	/* ptr to parent screen */
    SA_Draggable= SA_DUMMY + 0x001e,	/* defaults to TRUE */
    SA_Exclusive= SA_DUMMY + 0x001f,	/* won't share display */
    SA_SharePens= SA_DUMMY + 0x0020,
    SA_BackFill = SA_DUMMY + 0x0021,	/* backfill hook */
    SA_Interleaved=SA_DUMMY+ 0x0022,
    SA_Colors32 = SA_DUMMY + 0x0023,	/* pens are 32 bit per colour */
    SA_VideoControl=SA_DUMMY+0x0024,	/* value is taglist for VideoControl*/
    SA_FrontChild=SA_DUMMY + 0x0025,	/* ptr to front child screen */
    SA_BackChild= SA_DUMMY + 0x0026,	/* ptr to back child screen */
    SA_LikeWorkbench=SA_DUMMY+0x0027,	/* value 1, gets mode, depth, etc. */
    SA_Reserved = SA_DUMMY + 0x0028,
    SA_MinimizeISG=SA_DUMMY+ 0x0029;	/* don't always at least 3 lines gap */

/* error codes if SA_ErrorCode is used */

ulong
    OSERR_NOMONITOR	= 1,
    OSERR_NOCHIPS	= 2,
    OSERR_NOMEM 	= 3,
    OSERR_NOCHIPMEM	= 4,
    OSERR_PUBNOTUNIQUE	= 5,
    OSERR_UKNOWNMODE	= 6,
    OSERR_TOODEEP	= 7,
    OSERR_ATTACHFAIL	= 8,
    OSERR_NOTAVAILABLE	= 9;

type
    DrawInfo_t = struct {
	uint dri_Version;
	uint dri_NumPens;
	*uint dri_Pens;
	*TextFont_t dri_Font;
	uint dri_Depth;
	uint dri_Resolution_x;
	uint dri_Resolution_y;
	ulong dri_Flags;
	/* In V39 only: */
	*Image_t dri_CheckMark;
	*Image_t dri_AmigaKey;
	[5]ulong dri_Reserved;
    };

ulong DRIF_NEWLOOK = 0x00000001;

/* DrawInfo pen names */

uint
    DETAILPEN		= 0,
    BLOCKPEN		= 1,
    TEXTPEN		= 2,
    SHINEPEN		= 3,
    SHADOWPEN		= 4,
    FILLPEN		= 5,
    TEXTFILLPEN 	= 6,
    BACKGROUNDPEN	= 7,
    HIGHLIGHTTEXTPEN	= 8,
    BARDETAILPEN	= 9,
    BARBLOCKPEN 	= 10,
    BARTRIMPEN		= 11,

    NUMDRIPENS		= 12;

type
    NewScreen_t = struct {
	uint ns_LeftEdge, ns_TopEdge, ns_Width, ns_Height, ns_Depth;
	
	ushort ns_DetailPen, ns_BlockPen;
	
	uint ns_ViewModes;
	
	uint ns_Type;
	
	*TextAttr_t ns_Font;
	
	*char ns_DefaultTitle;
	
	*Gadget_t ns_Gadgets;
	
	*BitMap_t ns_CustomBitMap;
    },

    ExtNewScreen_t = struct {
	NewScreen_t ens_ns;
	*TagItem_t ens_Extension;
    };

extern
    CloseScreen(*Screen_t sc)void,
    DisplayBeep(*Screen_t sc)void,
    FreeScreenDrawInfo(*Screen_t sc; *DrawInfo_t dri)void,
    GetScreenData(*byte buffer; ulong size, typ; *Screen_t sc)bool,
    GetScreenDrawInfo(*Screen_t sc)*DrawInfo_t,
    LockPubScreen(*char name)*Screen_t,
    MakeScreen(*Screen_t sc)void,
    MoveScreen(*Screen_t sc; long deltaX, deltaY)void,
    OpenScreen(*ExtNewScreen_t newScreen)*Screen_t,
    ScreenToBack(*Screen_t sc)void,
    ScreenToFront(*Screen_t sc)void,
    ShowTitle(*Screen_t sc; ulong showIt)void,
    UnlockPubScreen(*char name; *Screen_t sc)void;
